osg::BufferTemplate< std::vector< T > > Class Template Reference

`#include <BufferTemplate>`

Inheritance diagram for osg::BufferTemplate< std::vector< T > >:

## Public Member Functions

| BufferTemplate ()
| BufferTemplate (const BufferTemplate< std::vector< T > > &bt, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual const GLvoid * | getDataPointer () const
virtual unsigned int | getTotalDataSize () const
const std::vector< T > & | getData () const
std::vector< T > & | getData ()
void | setData (const std::vector< T > &data)
Public Member Functions inherited from osg::BufferData
| BufferData ()
| BufferData (const BufferData &bd, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual osg::Array * | asArray ()
virtual const osg::Array * | asArray () const
virtual osg::PrimitiveSet * | asPrimitiveSet ()
virtual const osg::PrimitiveSet * | asPrimitiveSet () const
virtual osg::Image * | asImage ()
virtual const osg::Image * | asImage () const
void | setBufferObject (BufferObject *bufferObject)
BufferObject * | getBufferObject ()
const BufferObject * | getBufferObject () const
void | setBufferIndex (unsigned int index)
unsigned int | getBufferIndex () const
GLBufferObject * | getGLBufferObject (unsigned int contextID) const
GLBufferObject * | getOrCreateGLBufferObject (unsigned int contextID) const
void | setModifiedCallback (ModifiedCallback *md)
ModifiedCallback * | getModifiedCallback ()
const ModifiedCallback * | getModifiedCallback () const
void | dirty ()
void | setModifiedCount (unsigned int value)
unsigned int | getModifiedCount () const
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
void | releaseGLObjects (State *state=0) const
unsigned int | getNumClients () const
void | addClient (osg::Object *)
void | removeClient (osg::Object *)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~BufferTemplate ()
Protected Member Functions inherited from osg::BufferData
virtual | ~BufferData ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osg::BufferData
unsigned int | _modifiedCount
unsigned int | _bufferIndex
osg::ref_ptr< BufferObject > | _bufferObject
osg::ref_ptr< ModifiedCallback > | _modifiedCallback
unsigned int | _numClients
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

template<typename T>
class osg::BufferTemplate< std::vector< T > >

BufferTemplate specialization for std::vector

## Constructor & Destructor Documentation

## BufferTemplate() [1/2]

template<typename T>

osg::BufferTemplate< std::vector< T > >::BufferTemplate | ( |  | ) |

inline

References osg::BufferData::BufferData().

Referenced by BufferTemplate(), clone(), cloneType(), and isSameKindAs().

## BufferTemplate() [2/2]

template<typename T>

osg::BufferTemplate< std::vector< T > >::BufferTemplate | ( | const BufferTemplate< std::vector< T > > & | bt,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

inline

Copy constructor using CopyOp to manage deep vs shallow copy.

References osg::BufferData::BufferData(), BufferTemplate(), and osg::CopyOp::SHALLOW_COPY.

## ~BufferTemplate()

template<typename T>

virtual osg::BufferTemplate< std::vector< T > >::~BufferTemplate | ( |  | ) |

inline protected virtual

## Member Function Documentation

## className()

template<typename T>

virtual const char * osg::BufferTemplate< std::vector< T > >::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Reimplemented from osg::BufferData.

## clone()

template<typename T>

virtual Object * osg::BufferTemplate< std::vector< T > >::clone | ( | const CopyOp & |  | ) | const

inline virtual

Clone an object, with Object* return type. Must be defined by derived classes.

Implements osg::Object.

References BufferTemplate().

## cloneType()

template<typename T>

virtual Object * osg::BufferTemplate< std::vector< T > >::cloneType | ( |  | ) | const

inline virtual

Clone the type of an object, with Object* return type. Must be defined by derived classes.

Implements osg::Object.

References BufferTemplate().

## getData() [1/2]

template<typename T>

std::vector< T > & osg::BufferTemplate< std::vector< T > >::getData | ( |  | ) |

inline

## getData() [2/2]

template<typename T>

const std::vector< T > & osg::BufferTemplate< std::vector< T > >::getData | ( |  | ) | const

inline

## getDataPointer()

template<typename T>

virtual const GLvoid * osg::BufferTemplate< std::vector< T > >::getDataPointer | ( |  | ) | const

inline virtual

Implements osg::BufferData.

## getTotalDataSize()

template<typename T>

virtual unsigned int osg::BufferTemplate< std::vector< T > >::getTotalDataSize | ( |  | ) | const

inline virtual

Implements osg::BufferData.

## isSameKindAs()

template<typename T>

virtual bool osg::BufferTemplate< std::vector< T > >::isSameKindAs | ( | const Object * | obj | ) | const

inline virtual

Reimplemented from osg::BufferData.

References BufferTemplate(), and NULL.

## libraryName()

template<typename T>

virtual const char * osg::BufferTemplate< std::vector< T > >::libraryName | ( |  | ) | const

inline virtual

return the name of the object's library. Must be defined by derived classes. The OpenSceneGraph convention is that the namespace of a library is the same as the library name.

Reimplemented from osg::BufferData.

## setData()

template<typename T>

void osg::BufferTemplate< std::vector< T > >::setData | ( | const std::vector< T > & | data | ) |

inline

References osg::BufferData::dirty().

The documentation for this class was generated from the following file:

- BufferTemplate